<!doctype html>

<html lang="en">
<head>
  <meta charset="utf-8">
  <script src="../../dist/brd.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/qrious/4.0.2/qrious.min.js"></script>
  <script>
    var api = new BRD.API( { api: 'https://stage2.breadwallet.com' });
    var eme = new BRD.EME(api,'PWB');

    eme.ready().then(() => {
    
      api.fetch('/me').then(r => document.getElementById('me').innerHTML = JSON.stringify(r.result));
      
      function refreshInbox() {
        eme.fetch().then(r => {
          document.getElementById('inbox').innerHTML = JSON.stringify(eme.entries)
          document.getElementById('linked-with').innerHTML = JSON.stringify(eme.linkedPubkey({ acknowledged: false }));
        });
      };

      refreshInbox();

      function when(value) {
        return Promise.all([value]).then(array => array[0]);
      }

      eme.on('link',function(message,envelope,entry) {
        if(message.status == eme.proto.Status.ACCEPTED) {
          document.getElementById('linked-with').innerHTML = JSON.stringify(eme.linkedPubkey({ acknowledged: false }));

          if(entry.acknowledged == false) {
            Promise.all([
              eme.send(message.publicKey,'LINK',{ status: eme.proto.Status.ACCEPTED, publicKey: eme.api.privateKey.toPublicKey().toBuffer(), id: eme.Buffer.from(api.deviceID) }),
              eme.send(message.publicKey,'ACCOUNT_REQUEST', { scope: 'ETH' })
            ]).then(function() { return eme.ack(entry); }).catch(function(x) {
              console.error("Error linking: ",x);
            });
          }
        }
      });

      eme.on('account_response',function(message,envelope,entry) {
        if(entry.acknowledged == false) {
          eme.ack(entry);
        }

        eme.stopPolling();

        document.getElementById('account').innerHTML = JSON.stringify(message);
      });

      eme.startPolling();

    });

    function sendMeTheMoney() {
      var address = document.getElementById('address-input').value;
      var amount = document.getElementById('amount-input').value;
      var transactionSize = document.getElementById('transactionSize-input').value;
      var transactionFee = document.getElementById('transactionFee-input').value;

      eme.send(eme.linkedPubkey(),'PAYMENT_REQUEST',{
        scope: 'ETH',
        network: 'ropsten',
        address: address,
        amount: String(Number(amount)*1E18),
        memo: 'Some money',
        transactionSize: String(Number(transactionSize)),
        transactionFee: String(Number(transactionFee)*1E18),
      },{ pushNotification: { message: "Send me some money!" }});
    }

  </script>
</head>

<body>
  Some body.
  <h3>/me call:</h3>
  <div id="me"></div>
  <h3>Linked With:</h3>
  <div id="linked-with"></div>
  <h3>Account:</h3>
  <div id="account"></div>
  <h3>/inbox call: <span id="address"></span></h3>
  <div id="inbox"></div>

  <a id="deeplink">Deep Link</a>
  <canvas id="qr" width=300 height=300></canvas>

  <div>
    <h3>Send money</h3>
    <input id="address-input" placeholder="Address">
    <input id="amount-input" placeholder="Amount (ETH)">
    <input id="transactionSize-input" placeholder="Transaction Size">
    <input id="transactionFee-input" placeholder="Transaction Fee">
    <button onclick="sendMeTheMoney()">Send Some Money</button>
  </div>
  <div>Danger button: <button onclick="api.destroy();">Destroy</button>
    You'll want to reload after you destroy.  Any actions after you call it should fail.
  </div>
  <script>
    eme.ready().then(function() {
      document.getElementById('address').innerHTML = eme.base58Pubkey();
      
      document.getElementById('deeplink').href = eme.deepLinkUrl();
      
      var qr = new QRious({
        element: document.getElementById('qr'),
        value: eme.qrLinkUrl(),
      });
    });
</script>

</body>

</html>
